unit uCalculation;

interface

uses SysUtils;

const
  cPacket_Length      = 128;
  cAck_Length         = 8;
  cPropagation_Speed  = 2e8;
  cChannel_Length     = 250e3;
  cMbit               = Sqr(1024);

function DoCalculation(NotUsed : Pointer): integer;

implementation

uses uMain;



function DoCalculation(NotUsed : Pointer): integer;
// Arvutusfunktsioon
var iTstCycle   : integer; // Counter - mitmendat paketti parajasti saadetakse
    iNRCycles   : integer; // Mitu paketti ldse saadetakse
    iServFreq   : integer; // Teenindussagedus (Hz)
    ibError		  : integer;
    itError		  : integer;
    iErrCount   : integer;
    dErrRate    : Double;
    iRXTime		  : Double;
    iResult 	  : Double;  //sekundites
    dNorTime	  : Double;
    dErrTime	  : Double;
    bSuccessful : Boolean;
    bError			: Boolean;
begin
  with frmMain do begin
  	btCalculate.Enabled := False;
    btStop.Enabled := True;

    edTstDuration.ReadOnly 	:= True;
    edErrorRate.ReadOnly 		:= True;
    edServiceFreq.ReadOnly 	:= True;
    edTimeOut.ReadOnly 			:= True;

  	iNRCycles := StrToInt(edTstDuration.Text);
  	iServFreq := StrToInt(edServiceFreq.Text);
    dErrRate  := StrToFloat(edErrorRate.Text)*0.000001;
  	iResult		:= 0;
  	ibError		:= 0;
  	itError		:= 0;

  	Randomize;
    // Arvutatakse errorile kuluv aeg (128 biti vljastus + timeout) sekundites
    dErrTime := (StrToInt(edTimeOut.Text) + 1)*0.000001 +
                (2*cChannel_Length/cPropagation_Speed +
                (cPacket_Length+cAck_Length)/cMbit);

  	for iTstCycle := 1 to iNRCycles do begin
	    if bStop then Break;
    	bSuccessful := False;
    	repeat
      	// Arvutab Poissoni jaotuse jrgi paketi puhvrist vtmise aja sekundites
      	iRXTime := - ln(Random)/iServFreq;
      	// Arvutab: vigadeta paketi saatmise aeg + teeninduseks kulunud aeg + ACK tagasituleku aeg
      	dNorTime := 2*cChannel_Length/cPropagation_Speed +
                    (cPacket_Length+cAck_Length)/cMbit + iRXTime;
      	// Vaadatakse kas on piisavalt phjust teostada ks bitiviga
        bError := False;
        for iErrCount := 1 to (cPacket_Length + cAck_Length) do begin
      	  if Round(Random/dErrRate) = 1 then begin
            bError 	:= True;
        		Inc(ibError);
      		end;
        end;
        // Kui bitiviga esines, siis...
      	if bError then begin
        	iResult := iResult + dErrTime;
      	end else begin
        	// Kui bitiviga polnud vaja,
        	if dNorTime > dErrTime then begin
          	// kontroll, ega vastuvtuga liiga kaua ei venitatud (et timeout kiku lheks)
          	Inc(itError);
          	iResult := iResult + dErrTime;
        	end else begin
          	// Kui ka TimeOut'i ei letatud, siis saadi pakett nnelikult kohale ja ka ACK tagasi
    		  	iResult := iResult + dNorTime;
          	bSuccessful := True;
        	end;
      	end;
    	until bSuccessful;
      // Jrgmine rida hoolitseb progressbar'i eest
  		pbDone.Position := Trunc((iTstCycle*100)/iNRCycles);
	  	if bcbShow.Checked and (iTstCycle mod 200 = 0) then begin
  	  	// Konverteerib tulemuse millisekunditesse
  			edResultTime.Text := FloatToStrF(iResult*1000, ffNumber, 15, 2);
  			// Arvutab infoedastuskiiruse: 128*pakettide arv / nende saatmiseks kulunud aeg
  			edSpeed.Text := IntToStr(Trunc((128*iTstCycle)/iResult));
  			// Nitab bitivigade arvu
  			edbError.Text := IntToStr(ibError);
  			// Nitab vigade arvu tnu liiga lhikesele time-out'ile
  			edtoError.Text := IntToStr(itError);
    	end;
  	end;
    if bStop = False then begin
  		edResultTime.Text 		:= FloatToStrF(iResult*1000, ffNumber, 15, 2);
  		edSpeed.Text 					:= IntToStr(Trunc((128*iNRCycles)/iResult));
  		edbError.Text 				:= IntToStr(ibError);
  		edtoError.Text 				:= IntToStr(itError);
  		edResultTime.Enabled 	:= True;
  		edSpeed.Enabled 			:= True;
  		edbError.Enabled 			:= True;
  		edtoError.Enabled 		:= True;
    end else begin
  		edResultTime.Enabled 	:= False;
  		edSpeed.Enabled 			:= False;
  		edbError.Enabled 			:= False;
  		edtoError.Enabled 		:= False;
    end;
    btCalculate.Enabled 	    := True;
    btStop.Enabled 			    := False;
    edTstDuration.ReadOnly 	:= False;
    edErrorRate.ReadOnly 		:= False;
    edServiceFreq.ReadOnly 	:= False;
    edTimeOut.ReadOnly 			:= False;
  end;
  Beep;
end;

end.
