unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, Buttons, ComCtrls, Mask, BtChkBox, Gauges, uCalculation;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    GroupBox1: TGroupBox;
    edTstDuration: TEdit;
    GroupBox2: TGroupBox;
    edErrorRate: TEdit;
    Calculate1: TMenuItem;
    GroupBox3: TGroupBox;
    edServiceFreq: TEdit;
    GroupBox4: TGroupBox;
    edTimeOut: TEdit;
    btCalculate: TBitBtn;
    GroupBox5: TGroupBox;
    edResultTime: TEdit;
    BitBtn2: TBitBtn;
    GroupBox6: TGroupBox;
    gbSpeed: TGroupBox;
    edSpeed: TEdit;
    GroupBox7: TGroupBox;
    edbError: TEdit;
    Tingimused1: TMenuItem;
    N2: TMenuItem;
    GroupBox8: TGroupBox;
    edtoError: TEdit;
    bcbShow: TBitCheckBox;
    btStop: TBitBtn;
    Stop1: TMenuItem;
    mnuShow: TMenuItem;
    N3: TMenuItem;
    pbDone: TProgressBar;
    mnuOnTop: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure btCalculateClick(Sender: TObject);
    procedure edTstDurationChange(Sender: TObject);
    procedure edServiceFreqChange(Sender: TObject);
    procedure edTimeOutChange(Sender: TObject);
    procedure edErrorRateChange(Sender: TObject);
    procedure Tingimused1Click(Sender: TObject);
    procedure btStopClick(Sender: TObject);
    procedure mnuShowClick(Sender: TObject);
    procedure bcbShowClick(Sender: TObject);
    procedure mnuOnTopClick(Sender: TObject);
  private
    procedure UpdateForm;
    { Private declarations }
  public
    bStop : boolean;
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses uAbout, uTingimused;

{$R *.DFM}

procedure TfrmMain.UpdateForm;
// Kutsutakse, kui tehakse muutusi sisendandmetesse
begin
  edResultTime.Enabled 	:= False;
  edSpeed.Enabled 			:= False;
  edbError.Enabled 			:= False;
  edtoError.Enabled 		:= False;
  pbDone.Position 			:= 0;
end;

procedure TfrmMain.About1Click(Sender: TObject);
// Nitab About Form'i
begin
  if frmMain.FormStyle <> fsNormal then
  	frmMain.FormStyle := fsNormal;
	AboutBox.ShowModal;
  if mnuOnTop.Checked then frmMain.FormStyle := fsStayOnTop;
end;

procedure TfrmMain.Exit1Click(Sender: TObject);
// Programm lpetatakse
begin
	Application.Terminate;
end;

procedure TfrmMain.btCalculateClick(Sender: TObject);
var bOK   : Boolean;
		THID  : DWORD;
begin
  // Kui bOK jb teseks prast jrgmisi teste, siis hakatakse arvutama
  // vastasel korral teatatakse vastav veateade
  bOK := True;
  bStop := False;
  // Kontrollib, ega Pakettide arv thjaks pole jetud
  if edTstDuration.Text = '' then begin
    MessageDlg('Palun sisesta saadetavate pakettide arv!', mtWarning, [mbOK], 0);
    bOK := False;
  end;
  // Kontrollib, ega Teenindussageduse field thjaks pole jetud
  if edServiceFreq.Text = '' then begin
    MessageDlg('Palun sisesta teenindussagedus!', mtWarning, [mbOK], 0);
    bOK := False;
  end;
  // Kontrollib, et Teenindussagedus on le 1
  if StrToInt(edServiceFreq.Text) < 2 then begin
    MessageDlg('Teenindussagedus peab olema le 1!', mtWarning, [mbOK], 0);
    bOK := False;
  end;
  // Kontrollib, ega Time-Out field thjaks pole jetud
  if edTimeOut.Text = '' then begin
    MessageDlg('Palun sisesta Time-Out!', mtWarning, [mbOK], 0);
    bOK := False;
  end;
  // Kontrollib, ega Bitivea esinemise tenosuse field thjaks pole jetud
  if edErrorRate.Text = '' then begin
    MessageDlg('Palun sisesta bitivea esinemise tenosus!', mtWarning, [mbOK], 0);
    bOK := False;
  end;
  // Kontrollib, et tenosus le 1 ei lheks
  if StrToFloat(edErrorRate.Text) > 499999 then begin
    MessageDlg('Palun sisesta bitivea esinemise tenosus alla poole!', mtWarning, [mbOK], 0);
    bOK := False;
  end;
  // Kui kik fieldid on tidetud ja vastavad tingimustele:
  // Loon eraldi Threadi arvutuste jaoks
  // Vastasel korral vhegi pikemate arvutuste korral programm
  // tundub "lukus" olevat
  if bOK then CreateThread(nil, 0, @DoCalculation, nil, 0, THID);
end;

procedure TfrmMain.edTstDurationChange(Sender: TObject);
// See protseduur kontrollib kas sisestatud arv vastab tingimustele
begin
  UpdateForm;
  if edTstDuration.Text <> '' then begin
  	try
    	StrToInt(edTstDuration.Text);
  	except
    	on EConvertError do begin
      	edTstDuration.Text := '10000';
      	MessageDlg('This field allows only integers!', mtInformation, [mbOK], 0);
    	end;
  	end;
  end;
end;

procedure TfrmMain.edServiceFreqChange(Sender: TObject);
// See protseduur kontrollib kas sisestatud arv vastab tingimustele
begin
  UpdateForm;
  if edServiceFreq.Text <> '' then begin
  	try
    	StrToInt(edServiceFreq.Text);
  	except
    	on EConvertError do begin
      	edServiceFreq.Text := '3000';
      	MessageDlg('This field allows only integers!', mtInformation, [mbOK], 0);
    	end;
  	end;
  end;
end;

procedure TfrmMain.edTimeOutChange(Sender: TObject);
// See protseduur kontrollib kas sisestatud arv vastab tingimustele
begin
  UpdateForm;
  if edTimeOut.Text <> '' then begin
  	try
    	StrToInt(edTimeOut.Text);
  	except
    	on EConvertError do begin
      	edTimeOut.Text := '1000';
      	MessageDlg('This field allows only integers!', mtInformation, [mbOK], 0);
    	end;
  	end;
  end;
end;

procedure TfrmMain.edErrorRateChange(Sender: TObject);
// See protseduur kontrollib kas sisestatud arv vastab tingimustele
begin
  UpdateForm;
  if edErrorRate.Text <> '' then begin
  	try
    	StrToFloat(edErrorRate.Text);
  	except
    	on EConvertError do begin
      	edErrorRate.Text := '1';
      	MessageDlg('This field allows only floating point numbers and integers!', mtInformation, [mbOK], 0);
    	end;
  	end;
  end;
end;

procedure TfrmMain.Tingimused1Click(Sender: TObject);
begin
  if frmMain.FormStyle <> fsNormal then
  	frmMain.FormStyle := fsNormal;
	frmTingimused.ShowModal;
  if mnuOnTop.Checked then frmMain.FormStyle := fsStayOnTop;
end;

procedure TfrmMain.btStopClick(Sender: TObject);
begin
	bStop := True;
end;

procedure TfrmMain.mnuShowClick(Sender: TObject);
begin
  mnuShow.Checked := Not(mnuShow.Checked);
  bcbShow.Checked := mnuShow.Checked;
end;

procedure TfrmMain.bcbShowClick(Sender: TObject);
begin
	mnuShow.Checked := bcbShow.Checked;
end;

procedure TfrmMain.mnuOnTopClick(Sender: TObject);
begin
	mnuOnTop.Checked := Not(mnuOnTop.Checked);
  if mnuOnTop.Checked then frmMain.FormStyle := fsStayOnTop
  	else frmMain.FormStyle := fsNormal;
end;

initialization
  Application.HintColor := clAqua;

end.
